using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using AW.Portal.Data;
using System.ComponentModel;

public partial class DepartmentListingPart : 
	UserControl, IWebPartRow {

	private DataTable _table;

	protected override void OnInit(EventArgs e) {
		base.OnInit(e);
		if (!IsPostBack) {
			this.GridView1.SelectedIndex = 0;
		}
	}

	public DepartmentListingPart() {
		_table = new DataTable();

		_table.Columns.Add(new DataColumn("DepartmentID", typeof(int)));
		_table.Columns.Add(new DataColumn("Name", typeof(string)));
		_table.Columns.Add(new DataColumn("GroupName", typeof(string)));
		_table.Columns.Add(new DataColumn("EmployeeCount", typeof(string)));
	}
	
	public void GetRowData(RowCallback callback) {

		EnsureRowData();
		callback(_table.DefaultView[0]);
	}

	public PropertyDescriptorCollection Schema {
		get {
			EnsureRowData();
			return TypeDescriptor.GetProperties(_table.DefaultView[0]);
		}
	}

	private void EnsureRowData() {
		int idx = GridView1.SelectedIndex;
		int departmentID = (int)GridView1.DataKeys[idx].Value;

		DataLayer datalayer = new DataLayer();
		Department department = datalayer.GetDepartment(departmentID);

		DataRow row = _table.NewRow();
		row.ItemArray = new object[] { 
			department.ID, 
			department.Name, 
			department.GroupName, 
			department.EmployeeCount 
		};

		_table.Rows.Add(row);
	}



	[ConnectionProvider("Department Provider Data")]
	public IWebPartRow GetProviderData() {
		return this;
	}

}
