using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using AW.Portal.Data;
using System.Web.UI.MobileControls;
using System.Collections.Generic;

public partial class EmployeeListingPart : UserControl {

	IWebPartField _provider;
	int _data = 0;


	private void GetFieldData(object data) {
		int.TryParse( data.ToString(), out _data) ;
	}


	[ConnectionConsumer("Department Field Consumer")]
	public void SetProviderData(IWebPartField provider) {
		_provider = provider;
	}


	protected override void OnPreRender(EventArgs e) {
		if (_provider != null) {
			_provider.GetFieldValue(new FieldCallback(GetFieldData));
		}
		base.OnPreRender(e);
	}


protected override void Render(HtmlTextWriter writer) {

	DataLayer datalayer = new DataLayer() ;
	List<Employee> employees ;

	if (_provider != null && _data > 0) {
		employees = datalayer.ListEmployeesByDepartment(_data);
	} else {
		employees = datalayer.ListEmployees();
	}

	GridView1.DataSource = employees;
	GridView1.DataBind();

	base.Render(writer) ;
}
}
