using System;
using System.Collections.Generic;
using System.Text;
using System.Data.SqlClient;

namespace AW.Portal.Data {

    public interface IBusinessEntity {
        void Fill( SqlDataReader reader ) ;
    }
    
    public class Department : IBusinessEntity {
        private int _id;
        private string _name;
        private string _groupName;
		private int _employeeCount = 0;

        public int ID { get { return _id; } set { _id = value; } }
        public string Name { get { return _name; } set { _name = value; } }
        public string GroupName { get { return _groupName; } set { _groupName = value; } }
		public int EmployeeCount { get { return _employeeCount; } set { _employeeCount = value; } }

        public void Fill(SqlDataReader reader) {
            _id = reader.GetInt16(0);
			_name = reader.GetString(1);
			_groupName = reader.GetString(2);
			_employeeCount = reader.GetInt32(3);
			
        }
    }

    public class Employee : IBusinessEntity {
        private int _id;
        private string _firstName;
        private string _lastName;
        private string _jobTitle;

        public int ID { get { return _id; } set { _id = value; } }
        public string FirstName { get { return _firstName; } set { _firstName = value; } }
        public string LastName { get { return _lastName; } set { _lastName = value; } }
        public string JobTitle { get { return _jobTitle; } set { _jobTitle = value; } }

        public void Fill(SqlDataReader reader) {
            _id = reader.GetInt32(0);
            _firstName = reader.GetString(1);
            _lastName = reader.GetString(2);
            _jobTitle = reader.GetString(3);
        }
    }

    public class Candidate : IBusinessEntity {
        private int _id;
        private string _name;
        private string _skills;

        public int ID { get { return _id; } set { _id = value; } }
        public string Name { get { return _name; } set { _name = value; } }
        public string Skills { get { return _skills; } set { _skills = value; } }

        public void Fill(SqlDataReader reader) {
            _id = reader.GetInt32(0);
            _name = reader.GetString(1);
            _skills = reader.GetString(2);
        }
    }
}
