using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Diagnostics;

public class PortalWebPartManager : WebPartManager {

    public PortalWebPartManager() { }


    protected override void OnAuthorizeWebPart(WebPartAuthorizationEventArgs e) {

        if (string.IsNullOrEmpty(e.AuthorizationFilter)) {
            e.IsAuthorized = true;
            return;
        }

        string[] authorizedRoles =
            e.AuthorizationFilter.Split(new char[] { ',' });

        for (int i = 0; i < authorizedRoles.Length; i++) {
            if (IsUserInRole(authorizedRoles[i])) {
                e.IsAuthorized = true;
                return;
            }
        }
        e.IsAuthorized = isAuthorized;
    }



    bool IsUserInRole(string roleName) {
        if (Roles.Enabled) {
            return Roles.IsUserInRole(roleName);
        } else {
            return Context.User.IsInRole(roleName);
        }
    }

}
