using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class UserControls_ModeChanger : System.Web.UI.UserControl {

    protected override void OnLoad(EventArgs e) {
        base.OnLoad(e);

        WebPartManager wpm =
            WebPartManager.GetCurrentWebPartManager(this.Page);

        foreach (WebPartDisplayMode displayMode in wpm.SupportedDisplayModes) {

            if (displayMode.IsEnabled(wpm)) {
                DropDownList1.Items.Add(
                new ListItem(displayMode.Name)
                );
            }
        }
    }


    protected void DropDownList1_SelectedIndexChanged(object sender, EventArgs e) {
        WebPartManager wpm =
            WebPartManager.GetCurrentWebPartManager(this.Page);

        string modeName = DropDownList1.SelectedValue;
        WebPartDisplayMode mode = wpm.SupportedDisplayModes[modeName];
        if (mode != null)
            wpm.DisplayMode = mode;
    }



    protected override void OnPreRender(EventArgs e) {

        WebPartManager wpm =
            WebPartManager.GetCurrentWebPartManager(this.Page);

        WebPartDisplayMode currentMode = wpm.DisplayMode;

        DropDownList1.ClearSelection();
        DropDownList1.Items.FindByText(currentMode.Name).Selected = true;

    }

}
