using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using AW.Portal.Data;
using System.ComponentModel;

public partial class DepartmentListingPart : 
	UserControl, IWebPartRow {

	public DepartmentListingPart() { }
	
	protected override void OnInit(EventArgs e) {
		base.OnInit(e);
		if (!IsPostBack) {
			this.GridView1.SelectedIndex = 0;
		}
	}


	public void GetRowData(RowCallback callback) {

		int index = this.GridView1.SelectedIndex;
		int departmentID = (int)GridView1.DataKeys[index].Value;

		DataLayer datalayer = new DataLayer();
		Department department = datalayer.GetDepartment(departmentID);

		callback(department);
	}

	
	public PropertyDescriptorCollection Schema {
		get {
			PropertyDescriptorCollection props = 
				TypeDescriptor.GetProperties(typeof(Department));
			return props;
		}
	}

	[ConnectionProvider("Department Provider Data")]
	public IWebPartRow GetProviderData() {
		return this;
	}

}
