using System;
using System.Collections.Generic;
using System.Text;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI;

namespace AW.Portal.Web.SharedWebParts {
    public class TextWebPart : WebPart {
        public TextWebPart() { }

        Button btn1 = new Button();
        TextBox tb1 = new TextBox();
        Label label = new Label();
        bool _textLoaded = false;
        bool _isEditMode = false;


        private string _displayText = "Display Text";
        [WebBrowsable(false)]
        [Personalizable]
        public string DisplayText {
            get { return _displayText; }
            set {
                if (!_textLoaded)
                    _displayText = value;
            }
        }



        protected override void CreateChildControls() {
            this.Controls.Clear();

            tb1.TextMode = TextBoxMode.MultiLine;
            tb1.Columns = 65;
            tb1.Rows = 8;
            tb1.Visible = false;
            Controls.Add(tb1);

            label.Visible = true;
            Controls.Add(label);

            this.Controls.Add(new LiteralControl("<br />"));

            btn1.Page = this.Page;
            btn1.Click += new EventHandler(btn_Click);
            Controls.Add(btn1);
        }


        protected override void OnPreRender(EventArgs e) {
            base.OnPreRender(e);
            if (_isEditMode) {

                tb1.Visible = true;
                tb1.Text = _displayText;
                btn1.Text = "Commit Changes";
                btn1.CommandArgument = "Save";
                btn1.Visible = true;

                label.Visible = false;
            } else if (this.WebPartManager.DisplayMode == WebPartManager.EditDisplayMode && this.Zone.EditVerb.Visible) {

                label.Text = _displayText;
                label.Visible = true;
                tb1.Visible = false;
                btn1.Text = "Change Text";
                btn1.Visible = true;
                btn1.CommandArgument = "Edit";

            } else {
                label.Text = _displayText;
                label.Visible = true;
                tb1.Visible = false;
                btn1.Visible = false;
            }
        }


        void btn_Click(object sender, EventArgs e) {
            Button btn = (Button)sender;
            string foo = btn.CommandArgument;
            if (foo == "Edit") {
                this._isEditMode = true;
            } else {
                this._displayText = tb1.Text;
                _textLoaded = true;
            }

        }

    }
}
