using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class _Default : System.Web.UI.MasterPage {

    WebPartManager _wpm;

    protected override void OnInit(EventArgs e) {
        base.OnInit(e);

        bool requiresToggle = false;

        _wpm = WebPartManager.GetCurrentWebPartManager(this.Page);

        if (Request.QueryString["view"] != null) {
            string view = Request.QueryString["view"];
            if (view == "shared" && _wpm.Personalization.Scope != PersonalizationScope.Shared) {
                requiresToggle = true;
            }
        } else if (_wpm.Personalization.Scope == PersonalizationScope.Shared) {
            requiresToggle = true;
        }

        if (requiresToggle) {
            _wpm.Personalization.ToggleScope();
        }
    }


    protected override void OnPreRender(EventArgs e) {
        base.OnPreRender(e);

        this.pnlPageTasks.Visible =
            _wpm.Personalization.CanEnterSharedScope;

        if (this.pnlPageTasks.Visible) {

            string path = this.Request.Url.AbsolutePath;

            if (_wpm.Personalization.Scope == PersonalizationScope.User) {
                lblCurrentScope.Text = "Current Page Scope: Per-User";
                imgToggle.ImageUrl = "~/App_Themes/Images/allusr.GIF";
                lnkToggle.Text = "Show Shared View";
                lnkToggle.NavigateUrl = path + "?view=shared";
            } else {
                lblCurrentScope.Text = "Current Page Scope: Shared View";
                imgToggle.ImageUrl = "~/App_Themes/Images/perusr.GIF";
                lnkToggle.Text = "Show Per-User View";
                lnkToggle.NavigateUrl = path;
            }
        }

    }

}
