<%@ Control Language="C#" ClassName="YearPicker" %>
<%@ Implements Interface="System.Web.UI.WebControls.WebParts.IWebPartRow" %>
<%@ Import Namespace="System.ComponentModel" %>

<%-- 

This web part can be added to a page and used to provide a year that can filter any web parts that 
expose their data for a given year - such as SalesByYear

--%>

<script runat="server">
    
    public class YearData {
        public YearData(int year) { this._year = year; }
        private int _year = DateTime.Now.Year;

        public int Year {
            get { return _year; }
            set { _year = value; }
        }
	
    }
    
    
    protected override void OnLoad(EventArgs e) {
        base.OnLoad(e);
        if (!IsPostBack && this.ddYears.Items.Count == 0) {
            int currentYear = DateTime.Now.Year;
            for (int i = 9; i >= 0; i--) {
                int year = currentYear - i;
                this.ddYears.Items.Add(
                    new ListItem( year.ToString(), year.ToString() ) 
                    );
            }
        }
    }


    public void GetRowData(RowCallback callback) {

        int selectedYear = Convert.ToInt32(ddYears.SelectedItem.Value);
        
        callback(new YearData(selectedYear));
    }


    public PropertyDescriptorCollection Schema {
        get {

            PropertyDescriptorCollection props =
                TypeDescriptor.GetProperties(typeof( YearData ));
            return props;
        }
    }

    [ConnectionProvider("Year")]
    public IWebPartRow GetProviderData() {
        return this;
    }
    
    
    

</script>



<asp:DropDownList ID="ddYears" runat="server" AutoPostBack="true" />