using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.Generic;
using System.Collections;
using System.Security.Cryptography;
using System.IO;
using System.Text;


namespace WebPartTests {

    public class EncryptedDataWebPart : WebPart, IPersonalizable {

        public EncryptedDataWebPart() { }

        private string _message;
        [Personalizable]
        [WebBrowsable]
        public string Message {
            get { return _message; }
            set { _message = value; }
        }

        public override void RenderControl(HtmlTextWriter writer) {
            writer.Write(this.Message);
        }
	
        
        private bool _isDirty = true;
        public bool IsDirty {
            get {  return _isDirty; }
        }

        

        public new virtual void Load(PersonalizationDictionary state) {
            
            PersonalizationEntry pe = state["Message"] as PersonalizationEntry;

            if (pe != null ) {
                try {
                    string message = DecryptData(pe.Value.ToString());
                    this.Message = message;
                } catch (CryptographicException ex) {
                    this.Message = ex.Message;
                }
                
            }

           
        }

        public void Save(PersonalizationDictionary state) {

            string data = EncryptData(_message);

            PersonalizationEntry entry =
                new PersonalizationEntry(data, this.WebPartManager.Personalization.Scope);
            state["Message"] = entry;
        }



        #region Encryption Methods

        private static TripleDESCryptoServiceProvider _crypto = new TripleDESCryptoServiceProvider();

        public static string DecryptData(string encryptedData) {
            
            string decryptedData = "";

            if (!string.IsNullOrEmpty(encryptedData)) {
                byte[] base64 = Convert.FromBase64String(encryptedData);
                byte[] bytes = _crypto.CreateDecryptor().TransformFinalBlock(base64, 0, base64.GetLength(0));
                decryptedData = Encoding.Unicode.GetString(bytes);
            }
            
            return decryptedData;
        }

        public static string EncryptData(string data) {
            
            string encryptedData = "";

            if (!string.IsNullOrEmpty(data)) {

                byte[] inBytes = Encoding.Unicode.GetBytes(data);
                byte[] bytes = _crypto.CreateEncryptor().TransformFinalBlock(inBytes, 0, inBytes.GetLength(0));
                encryptedData = Convert.ToBase64String(bytes);
            }
            return encryptedData;
        }

        #endregion
    }



}