using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

/*
 * To use this example, include the web part on a web page with output tracing turned
 * on to view the trace statements and see where they occur during the page lifecycle.
 */

namespace WebPartTests {


    public class TrackingWebPart : WebPart, ITrackingPersonalizable {
        public TrackingWebPart() { }

        private string _data;
        [Personalizable]
        [WebBrowsable()]
        public string Data {
            get { return _data; }
            set { _data = value; }
        }


        public void BeginLoad() {
            Print("ITrackingPersonalizable.BeginLoad");
        }

        public void BeginSave() {
            Print("ITrackingPersonalizable.BeginSave");
        }

        public void EndLoad() {
            Print("ITrackingPersonalizable.EndLoad");
        }

        public void EndSave() {
            Print("ITrackingPersonalizable.EndSave");
        }

        public bool TracksChanges {
            get { return true; }
        }


        private void Print(string s) {
            Page.Trace.Write(s);
        }

    }
}