using System;
using System.Data;
using System.Collections;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;


/*
    To use this example, take turns to comment and uncomment the PropertyA and PropertyC properties.
    Any personalization data that is saved for either of those properties will be mapped to the other 
    one when it is no longer available.
 */ 
namespace WebPartTests {

    public class VersionedWebPart : WebPart, IVersioningPersonalizable {
        public VersionedWebPart() { }

        private string _propertyA;
        //[Personalizable]
        //[WebBrowsable]
        //public string PropertyA {
        //    get { return _propertyA; }
        //    set { _propertyA = value; }
        //}

        private string _propertyB;
        [Personalizable]
        [WebBrowsable]
        public string PropertyB {
            get { return _propertyB; }
            set { _propertyB = value; }
        }

        private string _propertyC;
        [Personalizable]
        [WebBrowsable]
        public string PropertyC {
            get { return _propertyC; }
            set { _propertyC = value; }
        }
	


        public override void RenderControl(HtmlTextWriter writer) {
            base.RenderControl(writer);

            writer.Write("Property A: " + this._propertyA);
            writer.WriteBreak();
            writer.Write("Property B: " + this._propertyB);
            writer.WriteBreak();
            writer.Write("Property C: " + this._propertyC);
            
        }

        public new void Load(IDictionary unknownProperties) {
            foreach (DictionaryEntry de in unknownProperties) {
                if (de.Key.ToString() == "PropertyA") {
                    _propertyC = de.Value.ToString();
                }

                if (de.Key.ToString() == "PropertyC") {
                    _propertyA = de.Value.ToString();
                }
            }

        }

    }
}