using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.Generic;

namespace WebPartTests {

    public class WebPartWithReferenceProperty : WebPart {

        private ComplexType _myProperty;
        [Personalizable]
        public ComplexType MyProperty {
            get { return _myProperty; }
            set { _myProperty = value; }
        }


        public void SetDirty() {
            this.SetPersonalizationDirty();
        }

        protected override void RenderContents(HtmlTextWriter writer) {
            base.RenderContents(writer);

            if (_myProperty != null) {
                writer.Write(MyProperty.A);
                writer.WriteBreak();

                foreach (string prop in MyProperty.B) {
                    writer.Write(prop);
                    writer.WriteBreak();
                }
            }
        }

    }


    [Serializable]
    public class ComplexType {

        public ComplexType() { }

        private string _a;
        public string A {
            get { return _a; }
            set { _a = value; }
        }


        private List<string> _b = new List<string>();
        public List<string> B {
            get { return _b; }
            set { _b = value; }
        }
    }
}