using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

namespace AW.Portal.Web {


    public class FavoritesEditorPart : EditorPart {

        TextBox txtDisplayName, txtDescription, txtUrl;

        FavoritesWebPart FavoritePart {
            get { return (FavoritesWebPart)this.WebPartToEdit; }
        }


        protected override void CreateChildControls() {

            Controls.Clear();

            Label lbl = new Label();
            lbl.ApplyStyle(this.Zone.LabelStyle);
            lbl.Text = "Display Name: ";
            lbl.Width = 120;
            this.Controls.Add(lbl);

            txtDisplayName = new TextBox();
            txtDisplayName.Columns = 30;
            this.Controls.Add(txtDisplayName);

            AddLineBreak();

            lbl = new Label();
            lbl.ApplyStyle(this.Zone.LabelStyle);
            lbl.Text = "Description: ";
            lbl.Width = 120;
            this.Controls.Add(lbl);

            txtDescription = new TextBox();
            txtDescription.TextMode = TextBoxMode.MultiLine;
            txtDescription.Rows = 5;
            txtDescription.Columns = 30;
            this.Controls.Add(txtDescription);

            AddLineBreak();

            lbl = new Label();
            lbl.Text = "Url: ";
            lbl.ApplyStyle(this.Zone.LabelStyle);
            lbl.Width = 120;
            this.Controls.Add(lbl);

            txtUrl = new TextBox();
            txtUrl.Columns = 30;
            this.Controls.Add(txtUrl);
        }


        private void AddLineBreak() {
            Literal ltl = new Literal();
            ltl.Text = "<br />";
            this.Controls.Add(ltl);
        }


        public override bool ApplyChanges() {

            string displayName = this.txtDisplayName.Text;
            string description = this.txtDescription.Text;
            string url = this.txtUrl.Text;

            if (!string.IsNullOrEmpty(displayName) && !string.IsNullOrEmpty(url)) {
                HyperlinkData hyperlink =
                    new HyperlinkData(displayName, description, url);

                this.txtDisplayName.Text = "";
                this.txtDescription.Text = "";
                this.txtUrl.Text = "";

                FavoritePart.AddHyperlink(hyperlink);
            }

            return true;
        }


        // nothing to do here because we aren't mapping 
        // any existing data from the FavoritesWebPart
        // onto our interface
        public override void SyncChanges() {
            return;
        }

    }
}