using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.ObjectModel;

namespace AW.Portal.Web {

    public class PortalWebPartZone : WebPartZone {

        protected override void OnCreateVerbs(WebPartVerbsEventArgs e) {
            base.OnCreateVerbs(e);

            this.EditVerb.Visible = false;
            Collection<WebPartVerb> verbs = new Collection<WebPartVerb>();

            HttpContext ctx = HttpContext.Current;
            
            if (ctx.Request.IsAuthenticated) {

                WebPartVerb editVerb = new WebPartVerb(
                    "editVerb", 
                    new WebPartEventHandler(HandleEditClick)
                    );

                verbs.Add(editVerb);

                if (this.WebPartManager.Personalization.Scope == PersonalizationScope.Shared) {
                    editVerb.Text = "Edit Shared Web Part";
                } else {
                    editVerb.Text = "Edit Web Part";
                }
            }
            e.Verbs = new WebPartVerbCollection(verbs);
        }


        void HandleEditClick(object sender, WebPartEventArgs e) {

            WebPart wp = e.WebPart;

            if (wp != this.WebPartManager.SelectedWebPart) {
                this.WebPartManager.DisplayMode = WebPartManager.EditDisplayMode;
                this.WebPartManager.BeginWebPartEditing(wp);
            }
        }
    }
}