using System;
using System.ComponentModel;
using System.Globalization;
using System.Drawing;

namespace WebPartTests {

    public class MyNumberTypeConverter : TypeConverter {
        public MyNumberTypeConverter() { }

        // Overrides the ConvertFrom method of TypeConverter.
        public override bool CanConvertFrom(ITypeDescriptorContext context, Type sourceType) {

            if (sourceType == typeof(string)) {
                return true;
            }
            return base.CanConvertFrom(context, sourceType);
        }


        // Overrides the ConvertFrom method of TypeConverter.
        public override object ConvertFrom(ITypeDescriptorContext context, CultureInfo culture, object value) {
            if (value is string) {
                string[] parts = ((string)value).Split(new char[] { '$' });
                return new MyNumberType(int.Parse(parts[0]), parts[1]);
            }
            return base.ConvertFrom(context, culture, value);
        }


        // Overrides the ConvertTo method of TypeConverter.
        public override object ConvertTo(ITypeDescriptorContext context, CultureInfo culture, object value, Type destinationType) {
            if (destinationType == typeof(string) && value != null) {
                return value.ToString();
            }
            return base.ConvertTo(context, culture, value, destinationType);
        }

    }
}