using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

namespace AW.Portal.Web {

    public class CollapsibleEditorZone : EditorZone {

        public CollapsibleEditorZone() { }

        bool editorPartsAdded = false;
        public bool EditorPartsAdded {
            get { return this.editorPartsAdded; }
            set { editorPartsAdded = value; }
        }


        protected override void RaisePostBackEvent(string eventArgument) {
            WebPartManager wpm = WebPartManager.GetCurrentWebPartManager(this.Page);

            if (eventArgument == "headerClose" || eventArgument == "cancel") {
                wpm.DisplayMode = WebPartManager.BrowseDisplayMode;
            } else if (eventArgument == "ok") {
                ApplyAndSyncChanges();
                wpm.DisplayMode = WebPartManager.BrowseDisplayMode;
            } else {
                base.RaisePostBackEvent(eventArgument);
            }
        }

        void ApplyAndSyncChanges() {
            foreach (EditorPart part in this.EditorParts) {
                part.ApplyChanges();
                part.SyncChanges();
            }
        }

        protected override EditorPartChrome CreateEditorPartChrome() {
            return new CollapsibleEditorPartChrome(this);
        }
    }
}