<%@ Page Language="C#" %>
<%@ Import Namespace="AW.Portal.Web" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Collections.Generic" %>
<%@ Import Namespace="System.Xml" %>
<%@ Register Namespace="AW.Portal.Web" TagPrefix="portal" %>
<%@ Import Namespace="AW.Portal.Web.SharedWebParts" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<script runat="server">
    
    XmlDocument _doc = new XmlDocument();


    protected string SelectedCatalog {
        get {
            return (ViewState["SelectedCatalog"] == null) ?
                "" : ViewState["SelectedCatalog"].ToString();
        }
        set {
            ViewState["SelectedCatalog"] = value;
        }
    }
    
    
    protected override void OnInit(EventArgs e) {
        base.OnInit(e);

        if (Request.QueryString["postbackReference"] != null) {
            this.hdnPostBackReference.Value =
                Request.QueryString["postbackReference"].ToString();
        }


        string xmlFilePath = Server.MapPath("~/App_Data/CatalogData.xml");
        _doc.Load(xmlFilePath);
        
        
        if (!IsPostBack) {
            BindCatalog();
            BindWebParts();
        }
    }


    void BindCatalog() {

        this.rptCatalogs.DataSource = _doc.DocumentElement.ChildNodes;
        this.rptCatalogs.DataBind();
        
    }

    void BindWebParts() {

        XmlNodeList nodes = null ;
        
        if (string.IsNullOrEmpty(this.SelectedCatalog)) {
            nodes = _doc.DocumentElement.ChildNodes[0].ChildNodes;
        } else {
            XmlNode node = 
                _doc.DocumentElement.SelectSingleNode(
                    "//catalog[@displayName='" + 
                    this.SelectedCatalog + "']"
                    );
            
            if (node != null)
                nodes = node.ChildNodes;
        }

        this.rptWebParts.DataSource = nodes;
        this.rptWebParts.DataBind();

    }
    
    
    
    protected void  rptWebParts_ItemDataBound(object sender, RepeaterItemEventArgs e)
    {

        XmlNode node = (XmlNode) e.Item.DataItem;
        string typeName = node.Attributes["typeName"].Value;

        HtmlAnchor btn = (HtmlAnchor)e.Item.FindControl("clickme");
        btn.Attributes.Add(
            "onclick",
            "CloseCatalogDialog(\"" +
                this.hdnPostBackReference.Value + "\", \"" +
                typeName + "\")"
            );
    }
    
    
    protected void rptCatalogs_ItemCommand(object source, RepeaterCommandEventArgs e) {
        this.SelectedCatalog = e.CommandArgument.ToString();
        BindWebParts();
    }
</script>


<script language="javascript" type="text/javascript">

    function CloseCatalogDialog(postBackReference, returnValue) {

        if( window.opener ) {
	        window.opener.DoCatalogPostBack(postBackReference, returnValue) ;
	        window.opener.focus() ;
	    }
    	
	    self.close() ;
    }

</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head id="Head1" runat="server">
    <title>Untitled Page</title>
</head>
<body style="margin: 10px">
    <form id="form1" runat="server">
    <asp:HiddenField ID="hdnPostBackReference" runat="server" />
    <h1>Gallery</h1>
    <div style="text-align: left">
        
        <div>
            <asp:Repeater ID="rptCatalogs" runat="server" OnItemCommand="rptCatalogs_ItemCommand">
                <ItemTemplate>
                    <asp:LinkButton ID="lnkCatalog" runat="server"
                        CommandArgument='<%# XPath("./@displayName") %>' 
                        Text='<%# XPath("./@displayName") %>' Font-Size="Large" 
                        BackColor="ControlLight" 
                        BorderColor="ControlDark"
                        BorderWidth="1px"
                        BorderStyle="Solid"
                        ForeColor="ControlText" />
                </ItemTemplate>
            </asp:Repeater>
        </div>
        
        <div style="border: solid 1px Black; padding: 8px;">
        <asp:Repeater ID="rptWebParts" runat="server" 
            OnItemDataBound="rptWebParts_ItemDataBound">
            <ItemTemplate>
                <a href="#" id="clickme" runat="server">
                    <asp:Label ID="Label2" 
                        runat="Server" 
                        Text='<%# XPath("./@displayName") %>' 
                        />
                </a><br />
            </ItemTemplate>
        </asp:Repeater>
        </div>
    </div>
    </form>
</body>
</html>
