using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class _Default : System.Web.UI.MasterPage {

    WebPartManager _wpm;

    protected override void OnInit(EventArgs e) {
        base.OnInit(e);

        _wpm = WebPartManager.GetCurrentWebPartManager(this.Page);
        
    }


    protected override void OnPreRender(EventArgs e) {
        base.OnPreRender(e);

        this.PageTasks1.Visible = _wpm.Personalization.CanEnterSharedScope;

        ToggleEditorZone();
    }



    private void ToggleEditorZone() {

        WebPartDisplayMode mode = this.WebPartManager1.DisplayMode;
        
        bool displaySidePanel = (
                (mode == WebPartManager.EditDisplayMode && this.WebPartManager1.SelectedWebPart != null)
                |
                (mode == WebPartManager.CatalogDisplayMode)
                |
                (mode == WebPartManager.ConnectDisplayMode && this.WebPartManager1.SelectedWebPart != null)
            );


        if (displaySidePanel) {
            this.container.Attributes.Add("class", "rz");
            this.toolpanel.Attributes.Add("class", "lzv");
        } else {
            this.container.Attributes.Add("class", "rzv");
            this.toolpanel.Attributes.Add("class", "lz");
        }
    }

}
