<%@ Control Language="C#" ClassName="PageTasks" %>
<%@ Import Namespace="AW.Portal.Web" %>

<script runat="server">

    PortalWebPartManager _wpm;

    protected override void OnInit(EventArgs e) {

        base.OnInit(e);

        _wpm = (PortalWebPartManager) WebPartManager.GetCurrentWebPartManager(this.Page);
    }


    protected override void OnLoad(EventArgs e) {
        base.OnLoad(e);

        if (_wpm.IsRevisionPage) {
            _wpm.DisplayMode = WebPartManager.CatalogDisplayMode;
        }
    }


    protected override void OnPreRender(EventArgs e) {
        base.OnPreRender(e);

        if (this.Visible) {

            if (_wpm.Personalization.Scope == PersonalizationScope.User) {
                lblCurrentScope.Text = "Current Page Scope: Per-User";
                imgToggle.ImageUrl = "~/Images/allusr.GIF";
                lnkToggle.Text = "Show Shared View";
            } else {
                lblCurrentScope.Text = "Current Page Scope: Shared View";
                imgToggle.ImageUrl = "~/Images/perusr.GIF";
                lnkToggle.Text = "Show Per-User View";
            }

            this.pnlCatalogMode.Visible =
                _wpm.DisplayMode != WebPartManager.CatalogDisplayMode;

            this.LinkButton2.Text =
                (_wpm.DisplayMode == WebPartManager.DesignDisplayMode) ?
                    "Browse" : "Design";

            this.lnkCreateRevision.Text =
                _wpm.IsRevisionPage ? 
                    "End Revising Content" : "Revise Content";

            this.pnlApprove.Visible = 
                _wpm.HasUnapprovedChanges && _wpm.IsRevisionPage;
        }
    }
    

    protected void LinkButton1_Click(object sender, EventArgs e) {
        _wpm.DisplayMode = WebPartManager.CatalogDisplayMode;
    }

    
    protected void LinkButton2_Click(object sender, EventArgs e) {

        if (LinkButton2.CommandArgument == "browse") {
            _wpm.DisplayMode = WebPartManager.BrowseDisplayMode;
            LinkButton2.CommandArgument = "design";
        } else {
            _wpm.DisplayMode = WebPartManager.DesignDisplayMode;
            LinkButton2.CommandArgument = "browse";
        }
    }

    protected void lnkToggle_Click(object sender, EventArgs e) {
        _wpm.Personalization.ToggleScope();
    }

    protected void lnkCreateRevision_Click(object sender, EventArgs e) {

        string url = Page.Request.Path;
        if (!_wpm.IsRevisionPage) { url += "?view=edit"; }
        Response.Redirect(url);
    }

    protected void lnkApproveChanges_Click(object sender, EventArgs e) {
        _wpm.CommitChanges();
    }


    protected void lnkConnect_Click(object sender, EventArgs e) {
        _wpm.DisplayMode = WebPartManager.ConnectDisplayMode;
    }
</script>


<div id="pagetasks">
    <asp:Label ID="lblCurrentScope" runat="server" Text="" Font-Bold="true" />
    &nbsp;&nbsp;
    <asp:Image 
        ImageUrl="~/Images/allusr.GIF" 
        runat="server" 
        ID="imgToggle" 
        ImageAlign="AbsBottom"
        BorderStyle="None" />
        
    <asp:LinkButton ID="lnkToggle" runat="server" OnClick="lnkToggle_Click" Text="Show Shared View" />
    
    <asp:PlaceHolder ID="pnlCatalogMode" runat="server" Visible="false">
        &nbsp;&nbsp;&nbsp;
        <img src="Images/Gallery.gif" border="0" alt="Display Gallery" /> 
        <asp:LinkButton ID="LinkButton1" runat="server" OnClick="LinkButton1_Click" Text="Add Web Parts" CausesValidation="false" />
    </asp:PlaceHolder>
    
    
    <img src="Images/Edit.gif" border="0" alt="Design Page" /> 
    <asp:LinkButton ID="LinkButton2" runat="server" OnClick="LinkButton2_Click" CommandArgument="design" Text="Design Page" CausesValidation="false" />
    
    &nbsp;&nbsp;
    <img 
        src="Images/Versioning.gif" 
        border="0" 
        alt="Create Revision" 
        /> 
    <asp:LinkButton 
        ID="lnkCreateRevision" 
        runat="server" 
        OnClick="lnkCreateRevision_Click" 
        Text="Create Revision" 
        CausesValidation="false" />

    <asp:PlaceHolder ID="pnlApprove" runat="server" Visible="false">
        &nbsp;&nbsp;
        <img src="Images/Approving.gif" border="0" alt="Approve Content" /> 
        <asp:LinkButton ID="lnkApproveChanges" runat="server" OnClick="lnkApproveChanges_Click" Text="Approve Content Changes" CausesValidation="false" />
    </asp:PlaceHolder>
    
    
    &nbsp;&nbsp;
    <img 
        src="Images/Gallery.gif" 
        border="0" 
        alt="Connect Web Parts" 
        /> 
    <asp:LinkButton 
        ID="lnkConnect" 
        runat="server" 
        OnClick="lnkConnect_Click" 
        Text="Connect Web Parts" 
        CausesValidation="false" />
    
</div>

