using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using AW.Portal.Data;

public partial class WebParts_DepartmentConsumer : System.Web.UI.UserControl {

    IWebPartField _provider;
    int _data = 0;


    private void GetFieldData(object data) {
        int.TryParse(data.ToString(), out _data);

        if (_data > 0) {
            DataLayer dl = new DataLayer() ;
            Department dept = dl.GetDepartment(_data);

            if (dept != null) {
                this.lblID.Text = dept.ID.ToString();
                this.lblName.Text = dept.Name;
                this.lblGroupName.Text = dept.GroupName;
                this.lblEmployees.Text = dept.EmployeeCount.ToString();
            }
        }
    }


    [ConnectionConsumer("Department Field Consumer")]
    public void SetProviderData(IWebPartField provider) {
        _provider = provider;
    }


    protected override void OnPreRender(EventArgs e) {
        if (_provider != null) {
            _provider.GetFieldValue(new FieldCallback(GetFieldData));
        }
        base.OnPreRender(e);
    }
}
